From 2687b83fee7f1951df3022cf24666ebec2ed5094 Mon Sep 17 00:00:00 2001
From: Tender Wang <tndrwang@gmail.com>
Date: Wed, 16 Oct 2024 16:59:47 +0800
Subject: [PATCH] Fix json_objectagg() crashed when including random() func.

---
 src/backend/nodes/nodeFuncs.c   | 2 --
 src/backend/parser/parse_expr.c | 2 +-
 2 files changed, 1 insertion(+), 3 deletions(-)

diff --git a/src/backend/nodes/nodeFuncs.c b/src/backend/nodes/nodeFuncs.c
index 0d00e029f3..9cf5832192 100644
--- a/src/backend/nodes/nodeFuncs.c
+++ b/src/backend/nodes/nodeFuncs.c
@@ -2334,8 +2334,6 @@ expression_tree_walker_impl(Node *node,
 			{
 				JsonValueExpr *jve = (JsonValueExpr *) node;
 
-				if (WALK(jve->raw_expr))
-					return true;
 				if (WALK(jve->formatted_expr))
 					return true;
 			}
diff --git a/src/backend/parser/parse_expr.c b/src/backend/parser/parse_expr.c
index 36c1b7a88f..ef0b560f5e 100644
--- a/src/backend/parser/parse_expr.c
+++ b/src/backend/parser/parse_expr.c
@@ -3890,7 +3890,7 @@ transformJsonAggConstructor(ParseState *pstate, JsonAggConstructor *agg_ctor,
 /*
  * Transform JSON_OBJECTAGG() aggregate function.
  *
- * JSON_OBJECT() is transformed into a JsonConstructorExpr node of type
+ * JSON_OBJECTAGG() is transformed into a JsonConstructorExpr node of type
  * JSCTOR_JSON_OBJECTAGG, which at runtime becomes a
  * json[b]_object_agg[_unique][_strict](agg->arg->key, agg->arg->value) call
  * depending on the output JSON format.  The result is coerced to the target
-- 
2.25.1

